"""
Python SDK for OpenFGA

API version: 1.x
Website: https://openfga.dev
Documentation: https://openfga.dev/docs
Support: https://openfga.dev/community
License: [Apache-2.0](https://github.com/openfga/python-sdk/blob/main/LICENSE)

NOTE: This file was auto generated by OpenAPI Generator (https://openapi-generator.tech). DO NOT EDIT.
"""

import pprint

from inspect import getfullargspec

from openfga_sdk.configuration import Configuration


class BatchCheckRequest:
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types: dict[str, str] = {
        "checks": "list[BatchCheckItem]",
        "authorization_model_id": "str",
        "consistency": "ConsistencyPreference",
    }

    attribute_map: dict[str, str] = {
        "checks": "checks",
        "authorization_model_id": "authorization_model_id",
        "consistency": "consistency",
    }

    def __init__(
        self,
        checks=None,
        authorization_model_id=None,
        consistency=None,
        local_vars_configuration=None,
    ):
        """BatchCheckRequest - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._checks = None
        self._authorization_model_id = None
        self._consistency = None
        self.discriminator = None

        self.checks = checks
        if authorization_model_id is not None:
            self.authorization_model_id = authorization_model_id
        if consistency is not None:
            self.consistency = consistency

    @property
    def checks(self):
        """Gets the checks of this BatchCheckRequest.


        :return: The checks of this BatchCheckRequest.
        :rtype: list[BatchCheckItem]
        """
        return self._checks

    @checks.setter
    def checks(self, checks):
        """Sets the checks of this BatchCheckRequest.


        :param checks: The checks of this BatchCheckRequest.
        :type checks: list[BatchCheckItem]
        """
        if self.local_vars_configuration.client_side_validation and checks is None:
            raise ValueError("Invalid value for `checks`, must not be `None`")

        self._checks = checks

    @property
    def authorization_model_id(self):
        """Gets the authorization_model_id of this BatchCheckRequest.


        :return: The authorization_model_id of this BatchCheckRequest.
        :rtype: str
        """
        return self._authorization_model_id

    @authorization_model_id.setter
    def authorization_model_id(self, authorization_model_id):
        """Sets the authorization_model_id of this BatchCheckRequest.


        :param authorization_model_id: The authorization_model_id of this BatchCheckRequest.
        :type authorization_model_id: str
        """

        self._authorization_model_id = authorization_model_id

    @property
    def consistency(self):
        """Gets the consistency of this BatchCheckRequest.


        :return: The consistency of this BatchCheckRequest.
        :rtype: ConsistencyPreference
        """
        return self._consistency

    @consistency.setter
    def consistency(self, consistency):
        """Sets the consistency of this BatchCheckRequest.


        :param consistency: The consistency of this BatchCheckRequest.
        :type consistency: ConsistencyPreference
        """

        self._consistency = consistency

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(lambda x: convert(x), value))
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(lambda item: (item[0], convert(item[1])), value.items())
                )
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BatchCheckRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BatchCheckRequest):
            return True

        return self.to_dict() != other.to_dict()
