"""
Python SDK for OpenFGA

API version: 1.x
Website: https://openfga.dev
Documentation: https://openfga.dev/docs
Support: https://openfga.dev/community
License: [Apache-2.0](https://github.com/openfga/python-sdk/blob/main/LICENSE)

NOTE: This file was auto generated by OpenAPI Generator (https://openapi-generator.tech). DO NOT EDIT.
"""

import pprint

from inspect import getfullargspec

from openfga_sdk.configuration import Configuration


class Condition:
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types: dict[str, str] = {
        "name": "str",
        "expression": "str",
        "parameters": "dict[str, ConditionParamTypeRef]",
        "metadata": "ConditionMetadata",
    }

    attribute_map: dict[str, str] = {
        "name": "name",
        "expression": "expression",
        "parameters": "parameters",
        "metadata": "metadata",
    }

    def __init__(
        self,
        name=None,
        expression=None,
        parameters=None,
        metadata=None,
        local_vars_configuration=None,
    ):
        """Condition - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._expression = None
        self._parameters = None
        self._metadata = None
        self.discriminator = None

        self.name = name
        self.expression = expression
        if parameters is not None:
            self.parameters = parameters
        if metadata is not None:
            self.metadata = metadata

    @property
    def name(self):
        """Gets the name of this Condition.


        :return: The name of this Condition.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Condition.


        :param name: The name of this Condition.
        :type name: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name

    @property
    def expression(self):
        """Gets the expression of this Condition.

        A Google CEL expression, expressed as a string.

        :return: The expression of this Condition.
        :rtype: str
        """
        return self._expression

    @expression.setter
    def expression(self, expression):
        """Sets the expression of this Condition.

        A Google CEL expression, expressed as a string.

        :param expression: The expression of this Condition.
        :type expression: str
        """
        if self.local_vars_configuration.client_side_validation and expression is None:
            raise ValueError("Invalid value for `expression`, must not be `None`")

        self._expression = expression

    @property
    def parameters(self):
        """Gets the parameters of this Condition.

        A map of parameter names to the parameter's defined type reference.

        :return: The parameters of this Condition.
        :rtype: dict[str, ConditionParamTypeRef]
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """Sets the parameters of this Condition.

        A map of parameter names to the parameter's defined type reference.

        :param parameters: The parameters of this Condition.
        :type parameters: dict[str, ConditionParamTypeRef]
        """

        self._parameters = parameters

    @property
    def metadata(self):
        """Gets the metadata of this Condition.


        :return: The metadata of this Condition.
        :rtype: ConditionMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Condition.


        :param metadata: The metadata of this Condition.
        :type metadata: ConditionMetadata
        """

        self._metadata = metadata

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(lambda x: convert(x), value))
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(lambda item: (item[0], convert(item[1])), value.items())
                )
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Condition):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Condition):
            return True

        return self.to_dict() != other.to_dict()
