"""
Python SDK for OpenFGA

API version: 1.x
Website: https://openfga.dev
Documentation: https://openfga.dev/docs
Support: https://openfga.dev/community
License: [Apache-2.0](https://github.com/openfga/python-sdk/blob/main/LICENSE)

NOTE: This file was auto generated by OpenAPI Generator (https://openapi-generator.tech). DO NOT EDIT.
"""

import pprint

from inspect import getfullargspec

from openfga_sdk.configuration import Configuration


class ExpandRequest:
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types: dict[str, str] = {
        "tuple_key": "ExpandRequestTupleKey",
        "authorization_model_id": "str",
        "consistency": "ConsistencyPreference",
        "contextual_tuples": "ContextualTupleKeys",
    }

    attribute_map: dict[str, str] = {
        "tuple_key": "tuple_key",
        "authorization_model_id": "authorization_model_id",
        "consistency": "consistency",
        "contextual_tuples": "contextual_tuples",
    }

    def __init__(
        self,
        tuple_key=None,
        authorization_model_id=None,
        consistency=None,
        contextual_tuples=None,
        local_vars_configuration=None,
    ):
        """ExpandRequest - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._tuple_key = None
        self._authorization_model_id = None
        self._consistency = None
        self._contextual_tuples = None
        self.discriminator = None

        self.tuple_key = tuple_key
        if authorization_model_id is not None:
            self.authorization_model_id = authorization_model_id
        if consistency is not None:
            self.consistency = consistency
        if contextual_tuples is not None:
            self.contextual_tuples = contextual_tuples

    @property
    def tuple_key(self):
        """Gets the tuple_key of this ExpandRequest.


        :return: The tuple_key of this ExpandRequest.
        :rtype: ExpandRequestTupleKey
        """
        return self._tuple_key

    @tuple_key.setter
    def tuple_key(self, tuple_key):
        """Sets the tuple_key of this ExpandRequest.


        :param tuple_key: The tuple_key of this ExpandRequest.
        :type tuple_key: ExpandRequestTupleKey
        """
        if self.local_vars_configuration.client_side_validation and tuple_key is None:
            raise ValueError("Invalid value for `tuple_key`, must not be `None`")

        self._tuple_key = tuple_key

    @property
    def authorization_model_id(self):
        """Gets the authorization_model_id of this ExpandRequest.


        :return: The authorization_model_id of this ExpandRequest.
        :rtype: str
        """
        return self._authorization_model_id

    @authorization_model_id.setter
    def authorization_model_id(self, authorization_model_id):
        """Sets the authorization_model_id of this ExpandRequest.


        :param authorization_model_id: The authorization_model_id of this ExpandRequest.
        :type authorization_model_id: str
        """

        self._authorization_model_id = authorization_model_id

    @property
    def consistency(self):
        """Gets the consistency of this ExpandRequest.


        :return: The consistency of this ExpandRequest.
        :rtype: ConsistencyPreference
        """
        return self._consistency

    @consistency.setter
    def consistency(self, consistency):
        """Sets the consistency of this ExpandRequest.


        :param consistency: The consistency of this ExpandRequest.
        :type consistency: ConsistencyPreference
        """

        self._consistency = consistency

    @property
    def contextual_tuples(self):
        """Gets the contextual_tuples of this ExpandRequest.


        :return: The contextual_tuples of this ExpandRequest.
        :rtype: ContextualTupleKeys
        """
        return self._contextual_tuples

    @contextual_tuples.setter
    def contextual_tuples(self, contextual_tuples):
        """Sets the contextual_tuples of this ExpandRequest.


        :param contextual_tuples: The contextual_tuples of this ExpandRequest.
        :type contextual_tuples: ContextualTupleKeys
        """

        self._contextual_tuples = contextual_tuples

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(lambda x: convert(x), value))
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(lambda item: (item[0], convert(item[1])), value.items())
                )
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExpandRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ExpandRequest):
            return True

        return self.to_dict() != other.to_dict()
