"""
Python SDK for OpenFGA

API version: 1.x
Website: https://openfga.dev
Documentation: https://openfga.dev/docs
Support: https://openfga.dev/community
License: [Apache-2.0](https://github.com/openfga/python-sdk/blob/main/LICENSE)

NOTE: This file was auto generated by OpenAPI Generator (https://openapi-generator.tech). DO NOT EDIT.
"""

import pprint

from inspect import getfullargspec

from openfga_sdk.configuration import Configuration


class ReadAuthorizationModelsResponse:
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types: dict[str, str] = {
        "authorization_models": "list[AuthorizationModel]",
        "continuation_token": "str",
    }

    attribute_map: dict[str, str] = {
        "authorization_models": "authorization_models",
        "continuation_token": "continuation_token",
    }

    def __init__(
        self,
        authorization_models=None,
        continuation_token=None,
        local_vars_configuration=None,
    ):
        """ReadAuthorizationModelsResponse - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._authorization_models = None
        self._continuation_token = None
        self.discriminator = None

        self.authorization_models = authorization_models
        if continuation_token is not None:
            self.continuation_token = continuation_token

    @property
    def authorization_models(self):
        """Gets the authorization_models of this ReadAuthorizationModelsResponse.


        :return: The authorization_models of this ReadAuthorizationModelsResponse.
        :rtype: list[AuthorizationModel]
        """
        return self._authorization_models

    @authorization_models.setter
    def authorization_models(self, authorization_models):
        """Sets the authorization_models of this ReadAuthorizationModelsResponse.


        :param authorization_models: The authorization_models of this ReadAuthorizationModelsResponse.
        :type authorization_models: list[AuthorizationModel]
        """
        if (
            self.local_vars_configuration.client_side_validation
            and authorization_models is None
        ):
            raise ValueError(
                "Invalid value for `authorization_models`, must not be `None`"
            )

        self._authorization_models = authorization_models

    @property
    def continuation_token(self):
        """Gets the continuation_token of this ReadAuthorizationModelsResponse.

        The continuation token will be empty if there are no more models.

        :return: The continuation_token of this ReadAuthorizationModelsResponse.
        :rtype: str
        """
        return self._continuation_token

    @continuation_token.setter
    def continuation_token(self, continuation_token):
        """Sets the continuation_token of this ReadAuthorizationModelsResponse.

        The continuation token will be empty if there are no more models.

        :param continuation_token: The continuation_token of this ReadAuthorizationModelsResponse.
        :type continuation_token: str
        """

        self._continuation_token = continuation_token

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(lambda x: convert(x), value))
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(lambda item: (item[0], convert(item[1])), value.items())
                )
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ReadAuthorizationModelsResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ReadAuthorizationModelsResponse):
            return True

        return self.to_dict() != other.to_dict()
