"""
Python SDK for OpenFGA

API version: 1.x
Website: https://openfga.dev
Documentation: https://openfga.dev/docs
Support: https://openfga.dev/community
License: [Apache-2.0](https://github.com/openfga/python-sdk/blob/main/LICENSE)

NOTE: This file was auto generated by OpenAPI Generator (https://openapi-generator.tech). DO NOT EDIT.
"""

import pprint

from inspect import getfullargspec

from openfga_sdk.configuration import Configuration


class User:
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types: dict[str, str] = {
        "object": "FgaObject",
        "userset": "UsersetUser",
        "wildcard": "TypedWildcard",
    }

    attribute_map: dict[str, str] = {
        "object": "object",
        "userset": "userset",
        "wildcard": "wildcard",
    }

    def __init__(
        self, object=None, userset=None, wildcard=None, local_vars_configuration=None
    ):
        """User - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._object = None
        self._userset = None
        self._wildcard = None
        self.discriminator = None

        if object is not None:
            self.object = object
        if userset is not None:
            self.userset = userset
        if wildcard is not None:
            self.wildcard = wildcard

    @property
    def object(self):
        """Gets the object of this User.


        :return: The object of this User.
        :rtype: FgaObject
        """
        return self._object

    @object.setter
    def object(self, object):
        """Sets the object of this User.


        :param object: The object of this User.
        :type object: FgaObject
        """

        self._object = object

    @property
    def userset(self):
        """Gets the userset of this User.


        :return: The userset of this User.
        :rtype: UsersetUser
        """
        return self._userset

    @userset.setter
    def userset(self, userset):
        """Sets the userset of this User.


        :param userset: The userset of this User.
        :type userset: UsersetUser
        """

        self._userset = userset

    @property
    def wildcard(self):
        """Gets the wildcard of this User.


        :return: The wildcard of this User.
        :rtype: TypedWildcard
        """
        return self._wildcard

    @wildcard.setter
    def wildcard(self, wildcard):
        """Sets the wildcard of this User.


        :param wildcard: The wildcard of this User.
        :type wildcard: TypedWildcard
        """

        self._wildcard = wildcard

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(lambda x: convert(x), value))
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(lambda item: (item[0], convert(item[1])), value.items())
                )
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, User):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, User):
            return True

        return self.to_dict() != other.to_dict()
